<template>
	<mind-layout>
		<mind-form v-model="recurso" @submit="onSubmit">
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Apellido">
								<el-input v-model="form.apellido"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="DNI">
								<el-input  type="text" v-model="form.dni" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Activo">
								<el-checkbox  v-model="form.activo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Fecha Ingreso">
								<el-input clearable type="date"  v-model="form.fechaIngreso" />
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Fecha Egreso">
								<el-input type="date" v-model="form.fechaEgreso" :disabled="form.activo"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Vencimiento Registro">
								<el-input type="date" v-model="form.vencRegistro" />
							</el-form-item>
						</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-layout>
</template>
<script>
import store from '@/store/choferes'
import {Rest} from '@/../vendor/mind-core-web'

export default {
	async created(){
		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/choferes`, 
			state: store.data,
			key: 'id'
		})

		let id = this.$route.params.id
		if(id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			this.recurso = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		}
	},

	methods: {
		async onSubmit(data) {
			let result, msg ;
			if(this.isNew) {
				await this.api.Post(data)
				.then(()=>{
					result = 'success'
					msg = 'Móvil creado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else {
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Móvil actualizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {},
			api: null
		}
	}
}
</script>